minispade.register('ember-timetree/~tests/views/timetree_view_test', "(function() {/*global $ */\n\n// Copyright (C) 2013 CrowdStrike, Inc. and contributors\n// This file is subject to the terms and conditions of the BSD License.\n// See the file LICENSE in the main directory for details\n\nvar view;\n\nfunction appendView(v) {\n\tv = v || view;\n  Ember.run(function() { v.appendTo('#qunit-fixture'); });\n}\n\nmodule('Ember.Timetree.TimetreeView', {\n\tteardown: function() {\n\t\tif (view) {\n\t\t\tEmber.run(function() { view.destroy(); });\n\t\t\tview = null;\n\t\t}\n\t}\n});\n\ntest(\"it's an Ember.View\", function() {\n  ok(Ember.View.detect(Ember.Timetree.TimetreeView), 'should be a subclass of Ember.View');\n});\n\ntest(\"can be inserted into the DOM\", function() {\n  view = Ember.Timetree.TimetreeView.create();\n\n  appendView();\n\n  equal($('svg', '#qunit-fixture').length, 1);\n});\n\ntest(\"renders content\", function() {\n\tvar content = [\n    {\n      \"id\"                : 1,\n      \"label\"             : \"One\",\n      \"start\"             : 1347800918,\n      \"end\"               : 1347802918\n    },\n    {\n      \"id\"                : 2,\n      \"label\"             : \"Two\",\n      \"start\"             : 1347800918,\n      \"end\"               : 1347801918\n    },\n    {\n      \"id\"                : 3,\n      \"label\"             : \"Three\",\n      \"start\"             : 1347802218,\n      \"end\"               : 1347802518,\n      \"parent\"            : 0\n    },\n    {\n      \"id\"                : 4,\n      \"label\"             : \"Four\",\n      \"start\"             : 1347801118,\n      \"end\"               : 1347801818,\n      \"parent\"            : 1\n    },\n    {\n      \"id\"                : 5,\n      \"label\"             : \"Five\",\n      \"start\"             : 1347801418,\n      \"end\"               : 1347802618,\n      \"parent\"            : 3\n    },\n    {\n      \"id\"                : 6,\n      \"label\"             : \"Six\",\n      \"start\"             : 1347801218,\n      \"end\"               : 1347801618,\n      \"parent\"            : 0\n    },\n    {\n      \"id\"                : 7,\n      \"label\"             : \"Seven\",\n      \"start\"             : 1347801418,\n      \"end\"               : 1347801618,\n      \"parent\"            : 5\n    },\n    {\n      \"id\"                : 8,\n      \"label\"             : \"Eight\",\n      \"start\"             : 1347801519,\n      \"end\"               : 1347801720\n    },\n    {\n      \"id\"                : 9,\n      \"label\"             : \"Nine\",\n      \"start\"             : 1347801619,\n      \"end\"               : 1347801720,\n      \"parent\"            : 7\n    }\n  ];\n\n  view = Ember.Timetree.TimetreeView.create({ content: content });\n\n  appendView();\n\n  equal(view.$('.content .bar').length, 9);\n});\n\ntest(\"handles transform: translate in Webkit\", function() {\n  var translate = \"translate(30.12, 42.999)\";\n  var match;\n  view = Ember.Timetree.TimetreeView.create();\n  match = view._translateRegex.exec(translate);\n  equal(match.length, 3);\n  equal(match[1], \"30.12\");\n  equal(match[2], \"42.999\");\n});\n\ntest(\"handles transform: translate in IE\", function() {\n  var translate = \"translate(30.12 42.999)\";\n  var match;\n  view = Ember.Timetree.TimetreeView.create();\n  match = view._translateRegex.exec(translate);\n  equal(match.length, 3);\n  equal(match[1], \"30.12\");\n  equal(match[2], \"42.999\");\n});\n\n})();\n//@ sourceURL=ember-timetree/~tests/views/timetree_view_test");